package soln;

import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Scanner;

import javax.net.ssl.HttpsURLConnection;

public class Labtest3_Sec03_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * 
		 */

		/**
		 * This labtest is based on Lab7.3. This labtest assumes you have
		 * completed this lab and builds upon it.
		 * 
		 * 
		 * [3 marks] Step 1: For the specified URL (found below), establish a
		 * connection with it and reads the returned document line by line,
		 * printing each line. At the end, print two empty lines.
		 * 
		 * NOTE1, found below, explains the URL a little further.
		 * 
		 * NOTE2, found below, provides a small overview of how the class URL
		 * works.
		 */

		// URL to be used:
		// http://localhost/course_archive/2010-11/W/1720/labtest/LT3/haiku1.txt

		URL url = new URL(
				"http://localhost/course_archive/2010-11/W/1720/labtest/LT3/haiku1.txt");
		InputStream inputStream = url.openStream();
		// System.out.println(url.getFile());

		Scanner input = new Scanner(inputStream);
		while (input.hasNext()) {
			System.out.println(input.nextLine());
		}

		System.out.println();
		System.out.println();

		/**
		 * [2 marks] Step 2: now retrieve the document again and repeat the
		 * line-by-line printing. At the start of each output line, print the
		 * prefix "Haiku, Line x: ", where x is the actual line number, starting
		 * with line number 1. At the end, print two empty lines.
		 * 
		 */
		inputStream = url.openStream();
		input = new Scanner(inputStream);
		int x = 1;
		while (input.hasNext()) {
			System.out.println("Haiku, Line " + x + ": " + input.nextLine());
			x++;
		}
		
		System.out.println();
		System.out.println();


		/**
		 * [3 marks] Step 3: now retrieve the document at the next specified URL
		 * (found below). Read lines of file and parse them to strip off the
		 * html tags. Print out only only the text that is tagged but not any of
		 * the html tags. Include the prefix as described in Step 2. At the end,
		 * print two empty lines.
		 * 
		 * You may assume that no tags are self-closing, like <br/>
		 * (Non self-closing means all the tags occur in pairs, with text an
		 * opening tag like
		 * <p>
		 * and a closing tag like
		 * </p>
		 * Your solution should work for any type of html tag and not solely the
		 * paragraph tag
		 * <p>
		 * . However, if you cannot get your solution to work like this, at
		 * least make it work for the
		 * <p>
		 * tag for part marks.
		 */

		// URL to be used:
		// http://localhost/course_archive/2010-11/W/1720/labtest/LT3/haiku2.html

		url = new URL(
				"http://localhost/course_archive/2010-11/W/1720/labtest/LT3/haiku2.html");
		inputStream = url.openStream();
		input = new Scanner(inputStream);
		x = 1;
		while (input.hasNext()) {
			String theLine = input.nextLine();
			theLine = theLine.replaceAll("<.>", "");
			theLine = theLine.replaceAll("</.>", "");
			System.out.println("Haiku, Line " + x + ": " + theLine);
			x++;
		}

		System.out.println();
		System.out.println();

		/**
		 * [3 marks] Step 3: now retrieve the document at the next specified URL
		 * (found below). Perform the same steps as above, except this time
		 * generalize your code to handle the tags <a href="URL"> and </a>. If
		 * you encounter any content tagged with this particular tag, then do
		 * not print the content (i.e., the text that is found between the
		 * tags). Instead, retrieve the specified content and print that
		 * instead.
		 *  
		 * 
		 * You may make the following assumptions:
		 * 
		 * - the tags <a href="URL"> and </a> will appear together within the
		 * same line of text.
		 * 
		 * - the URL specified as the href value will be a full URL and not a
		 * relative URL
		 * 
		 * - the URL specified as the href value will correspond to txt file
		 * that consists of a single line of text, which will not be another URL
		 * 
		 * HINT: the regular expression that will match the URL's in this
		 * labtest is "\"http://localhost(/([\\w/_\\.-]*(\\?\\S+)?)?)?\""
		 * 
		 */

		// URL to be used:
		// http://localhost/course_archive/2010-11/W/1720/labtest/LT3/haiku3.html
		String REGEX_URL = "\"http://localhost(/([\\w/_\\.-]*(\\?\\S+)?)?)?\"";

		url = new URL(
				"http://localhost/course_archive/2010-11/W/1720/labtest/LT3/haiku3.html");
		inputStream = url.openStream();
		input = new Scanner(inputStream);
		x = 1;
		while (input.hasNext()) {
			String theLine = input.nextLine();
			if (theLine.matches(".*<a href\\=" + REGEX_URL + ">.*")) {
				// System.out.println("zzz" + x + ": " + theLine);
				theLine = theLine.replaceAll(".*<a href\\=", "");
				theLine = theLine.replaceAll(">.*", "");
				theLine = theLine.replaceAll("\"", "");
				// System.out.println(theLine);

				URL subURL = new URL(theLine);
				InputStream inputStream2 = subURL.openStream();
				Scanner scan2 = new Scanner(inputStream2);
				while (scan2.hasNext()) {
					System.out.println("Haiku, Line " + x + ": "
							+ scan2.nextLine());
				}
			} else {
				theLine = theLine.replaceAll("<.>", "");
				theLine = theLine.replaceAll("</.>", "");
				System.out.println("Haiku, Line " + x + ": " + theLine);
			}
			x++;
		}

		System.out.println("**");

	}
	/**
	 * NOTE1:
	 * 
	 * This machine is running in labtest mode, which means that this machine
	 * cannot connect to the external web.
	 * 
	 * Notice that if you type http://localhost in your browser window, you see
	 * content because your browser is performing a http request to a local
	 * resource. The http request is not being made to a server on the web, but
	 * rather to a web server that is running locally (in fact, on the same
	 * computer as this app). The web server that is running locally is serving
	 * up content through the http scheme.
	 * 
	 * You can see the same content by looking at the URL using your web
	 * browser.
	 */

	/**
	 * NOTE2:
	 * 
	 * The Class URL represents a Uniform Resource Locator, a pointer to a
	 * "resource" on the World Wide Web. The pointer includes the scheme or
	 * manner with which the resource should be obtained. A common scheme is
	 * http.
	 * 
	 * A web browser will usually dereference the URL http://example.org by
	 * performing an HTTP request (such as GET) to the host at example.org. If
	 * we want to retrieve the resource from within our java app, then we must
	 * use the services of the class URL. The class provides the method
	 * openConnection(), which opens a connection to the URL the object is
	 * encapsulating. The method returns an InputStream for reading from that
	 * connection. Since our URL makes use of the http scheme, this means that
	 * in opening the connection, this method will issue a GET request to the
	 * webserver at the specified domain. If the URL specifies a scheme other
	 * than http (such as ftp or https), then the openConnection() method may
	 * behave differently (and issue a different command, depending on the
	 * specifications of the particular protocol).
	 */

}
